package com.fca.uconnect.global;

import com.amazonaws.services.iot.client.AWSIotException;
import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotMqttClient;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectAny;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectMessage;
import com.fca.uconnect.global.GlobalUconnectExtSQDF.SQDFRequest;
import com.fca.uconnect.global.GlobalUconnectExtSQDF.SQDFRequest.SQDFCommand;
import com.google.protobuf.ExtensionRegistry;

public class SDPExampleForSQDF {
private String clientId; // The clientId is unique to the device and obtained from the client X.509 certificate CN.
private int messageId; // The messageId is a sequential number incremented and assigned to each message sent from the client.
private AWSIotMqttClient mqttClient; // The mqtt client object from the AWS IoT client library. 
private AWSIotTopic iotTopic; // The Topic object to subscribe for inbound messages.
private ExtensionRegistry extRegistry; // Google protocol buffers extension registry instance.
 

public SDPExampleForSQDF() {
	extRegistry = ExtensionRegistry.newInstance();
	extRegistry.add(GlobalUconnectExtSQDF.sqdfResponse);
	
}
public static void main(String[] args) {
	SDPExampleForSQDF m = new SDPExampleForSQDF();
	m.process();
}
public UconnectMessage getSQDFRequestMsg() {
	messageId++;

	SQDFRequest sreq = SQDFRequest.newBuilder()
			.setCommand(SQDFCommand.SendData)
			.build();
	UconnectMessage msg = UconnectMessage.newBuilder()
		.setTimestamp(System.currentTimeMillis())
		.setMessageId(messageId)
		.addMessages(UconnectAny.newBuilder().
		 setExtension(GlobalUconnectExtSQDF.sqdfRequest, sreq))
		.build();
	return msg;		
}

public void process() {

	mqttClient = new AWSIotMqttClient("endpoint", clientId, "awsAccessKeyId", "awsSecretAccessKey");

try {			
mqttClient.connect();						
 iotTopic = new AWSIotTopic("/SQDF/#",AWSIotQos.QOS1){
	public void onMessage(AWSIotMessage msg) {
try {
	
	UconnectMessage	msgIn = UconnectMessage.parseFrom(msg.getPayload(),extRegistry);			
	GlobalUconnectExtSQDF.SQDFResponse SQDFRespMsg = msgIn.getMessages(0).getExtension(GlobalUconnectExtSQDF.sqdfResponse);
	if (SQDFRespMsg!=null) {
		//receive sqdfresponse.
		
	}
} catch( Exception ex) {
	ex.printStackTrace();
}
}
};

mqttClient.subscribe(iotTopic);
sendMessage(getSQDFRequestMsg());
} catch (AWSIotException e) {
	System.out.println("Caught Exception "+e);
	e.printStackTrace();
}

}


public void sendMessage(UconnectMessage msg) {
final byte[] msgOut = msg.toByteArray();

new Thread(new Runnable() {

    @Override
public void run() {
try {	
	mqttClient.publish(clientId+"/SQDF/", AWSIotQos.QOS1, msgOut);
} catch (AWSIotException e) {
	System.out.println("Caught Exception "+e);
				e.printStackTrace();
			}		    	
	    }
	    
	}).start();
}
}
